import pygame

import scene

tiles = {
    "0":("plainwhite10",10,True,"white"),
    "I":("pillar",30,True,"white"),
    "r":("red10",10,True,"red"),
    "y":("yellow10",10,True,"yellow"),
    "b":("blue10",10,True,"blue"),
    "g":("green10",10,True,"green"),
    "o":("orange10",10,True,"orange"),
    "p":("purple10",10,True,"purple"),
    "B":("brown10",10,True,"brown"),
    "<":("westslopewhite10",5,True,"white"),
    "^":("northslopewhite10",5,True,"white"),
    ">":("eastslopewhite10",5,True,"white"),
    "v":("southslopewhite10",5,True,"white"),
    "Sr":"red",
    "Sg":"green",
    "Sb":"blue",
    "Sy":"yellow",
    "Sp":"purple",
    "So":"orange",
    }

def load_map(file,master):
    f = open("data/maps/%s.txt"% file)
    lines = f.readlines()

    # Find the length. Maps must be square and all heights the same size/shape.
    length = len(lines[0].split())
        
    # Piece together the map
    floor = {}

    x = y = 0
    for L in lines:
        if L.startswith("\n"):
            x = y = 0
            continue
        for t in L.split():
            if t != "-":
                tile = tiles[t]
                if floor.has_key((x,y)):
                    s = floor[(x,y)]
                else:
                    floor[(x,y)] = scene.Stack((x,y))
                    s = floor[(x,y)]
                if t.startswith("S"):
                    s.add(scene.Spawn(tile,(x,y,s.height())))
                else:
                    s.add(scene.Tile(tile[0],(x,y,s.height()),tile[1],tile[2],colour = tile[3]))
            x += 1
        y += 1
        x = 0

    return Map(master,length,floor)

class Map:
    def __init__(self,master,length,data):
        self.master = master
        self.length = length
        self.data = data
        self.cursor = scene.Cursor("circle",(length/2,length/2))
        self.data[(self.cursor.x,self.cursor.y)].add(self.cursor,cur=True)
    def draw(self):
        screen = self.master.screen
        offset = self.master.camera.offset()
        for p in self.order():
            self.data[p].draw(screen,offset)
    def order(self):
        for i in range(self.length*2-1):
            for t in range(i+1):
                if i-t < self.length and t < self.length:
                    yield(i-t,t)
                







